//Register file
//Kamyar Rafati & Naeem Esfahani

module RegFile_32bit (RAdr1, Out1, RAdr2, Out2, WAdr, WData, RegWrite, CLK);

	input[4:0]		RAdr1, RAdr2, WAdr;
	input[31:0]		WData;
	input			RegWrite, CLK;
	output[31:0]	Out1, Out2;
	reg[31:0]		Out1, Out2;
//We split them so we'll have easier test. It means that we can see them in the waveform
	reg[31:0]		Reg1, Reg2, Reg3, Reg4, Reg5, Reg6, Reg7, Reg8, Reg9, Reg10, 
					Reg11, Reg12, Reg13, Reg14, Reg15, Reg16, Reg17, Reg18, Reg19, 
					Reg20, Reg21, Reg22, Reg23, Reg24, Reg25, Reg26, Reg27, Reg28, Reg29, 
					Reg30, Reg31;

// Write
	always @(WAdr or WData or RegWrite or posedge CLK)
	begin
		if (RegWrite &&  CLK)
			case (WAdr)
				1: Reg1=WData;
				2: Reg2=WData;
				3: Reg3=WData;
				4: Reg4=WData;
				5: Reg5=WData;
				6: Reg6=WData;
				7: Reg7=WData;
				8: Reg8=WData;
				9: Reg9=WData;
				10: Reg10=WData;
				11: Reg11=WData;
				12: Reg12=WData;
				13: Reg13=WData;
				14: Reg14=WData;
				15: Reg15=WData;
				16: Reg16=WData;
				17: Reg17=WData;
				18: Reg18=WData;
				19: Reg19=WData;
				20: Reg20=WData;
				21: Reg21=WData;
				22: Reg22=WData;
				23: Reg23=WData;
				24: Reg24=WData;
				25: Reg25=WData;
				26: Reg26=WData;
				27: Reg27=WData;
				28: Reg28=WData;
				29: Reg29=WData;
				30: Reg30=WData;
				31: Reg31=WData;
			endcase
		end
		
//Read
	always @(negedge CLK)
	begin
		case(RAdr1)
			0: Out1 = 0;
			1: Out1 = Reg1;
			2: Out1 = Reg2;
			3: Out1 = Reg3;
			4: Out1 = Reg4;
			5: Out1 = Reg5;
			6: Out1 = Reg6;
			7: Out1 = Reg7;
			8: Out1 = Reg8;
			9: Out1 = Reg9;
			10: Out1 = Reg10;
			11: Out1 = Reg11;
			12: Out1 = Reg12;
			13: Out1 = Reg13;
			14: Out1 = Reg14;
			15: Out1 = Reg15;
			16: Out1 = Reg16;
			17: Out1 = Reg17;
			18: Out1 = Reg18;
			19: Out1 = Reg19;
			20: Out1 = Reg20;
			21: Out1 = Reg21;
			22: Out1 = Reg22;
			23: Out1 = Reg23;
			24: Out1 = Reg24;
			25: Out1 = Reg25;
			26: Out1 = Reg26;
			27: Out1 = Reg27;
			28: Out1 = Reg28;
			29: Out1 = Reg29;
			30: Out1 = Reg30;
			31: Out1 = Reg31;
		endcase
		case(RAdr2)
			0: Out2 = 0;
			1: Out2 = Reg1;
			2: Out2 = Reg2;
			3: Out2 = Reg3;
			4: Out2 = Reg4;
			5: Out2 = Reg5;
			6: Out2 = Reg6;
			7: Out2 = Reg7;
			8: Out2 = Reg8;
			9: Out2 = Reg9;
			10: Out2 = Reg10;
			11: Out2 = Reg11;
			12: Out2 = Reg12;
			13: Out2 = Reg13;
			14: Out2 = Reg14;
			15: Out2 = Reg15;
			16: Out2 = Reg16;
			17: Out2 = Reg17;
			18: Out2 = Reg18;
			19: Out2 = Reg19;
			20: Out2 = Reg20;
			21: Out2 = Reg21;
			22: Out2 = Reg22;
			23: Out2 = Reg23;
			24: Out2 = Reg24;
			25: Out2 = Reg25;
			26: Out2 = Reg26;
			27: Out2 = Reg27;
			28: Out2 = Reg28;
			29: Out2 = Reg29;
			30: Out2 = Reg30;
			31: Out2 = Reg31;
		endcase
	end
endmodule
