//Mips ALU Control
//Kamyar Rafati & Naeem Esfahani

module ALU_control (ALUop, Funct, Opcode);
	input[5:0]	Funct;
	input[1:0]	ALUop;
	output[2:0]	Opcode;
	reg[2:0]	Opcode;

	always @(ALUop or Funct)
	begin
		case(ALUop)
		0:  Opcode = 2;
		1:  Opcode = 6;
		2:  case(Funct)
			32: Opcode = 2;
			34: Opcode = 6;
			36: Opcode = 0;
			37: Opcode = 1;
			42: Opcode = 7;
			endcase
		endcase
	end
endmodule

		