//JumpBox: Shifts and combines bits for jump address calculation
//Kamyar Rafati & Naeem Esfahani

module JumpBox (PC, Address, y);
	input[25:0]		Address;
	input[3:0]		PC;
	output[31:0]	y;
	reg[31:0]		y;

	always @(PC or Address)
	begin
		y[27:0] = Address * 4;
		y[31:27] = PC;
	end
endmodule
