//1 bit Register
//Kamyar Rafati & Naeem Esfahani

module Reg_1bit (MData, Y, enable, reset, CLK);
	input	MData;
	input	CLK, reset, enable;
	output	Y;
	reg		Y;
	reg		Data;

	always @(negedge CLK or MData)
	begin
		if (!reset && enable && !CLK) Data=MData;
	end

	always @(posedge CLK)
	begin
		Y = Data;
	end

	always @(posedge reset)
	begin
		Data = 0;
	end
endmodule
