//16 bit to 32 bit sign extender
//Kamyar Rafati & Naeem Esfahani

module SignExtend_32bit (a, y);
	input[15:0]		a;
	output[31:0]	y;
	reg[31:0]		y;

	always @(a)
	begin
		if (a[15] == 1)
			y[31:16] = 16'b1111111111111111;
		else
			y[31:16] = 16'b0000000000000000;
			
		y[15:0] = a;
	end
endmodule
